<?php  
defined('C5_EXECUTE') or die("Access Denied.");
class ImageBannerBlockController extends BlockController {
	
	protected $btTable = 'btImageBanner';
	protected $btInterfaceWidth = "550";
	protected $btInterfaceHeight = "500";
 	protected $btWrapperClass = 'ccm-ui';
 
	/** 
	 * Used for localization. If we want to localize the name/description we have to include this
	 */
	public function getBlockTypeDescription() {
		return t("A block that creates a banner by automatically resizing and cropping a selected series of images.");
	}
	
	public function getBlockTypeName() {
		return t("Image Banner");
	}
	
	public function getJavaScriptStrings() {
		return array(
			'choose-min-1' => t('Please choose at least one image.'),
			'enter_width' => t('Please enter a valid width.'),
			'enter_height' => t('Please enter a valid height.')		 
		);
	}
	 
	function loadImages(){
		$sql = "SELECT * FROM btImageBannerImg, Files WHERE btImageBannerImg.fID = Files.fID and bID=".intval($this->bID).' ORDER BY position';
		$db = Loader::db();
		$this->images=$db->getAll($sql); 
	}
	
	function delete(){
		$db = Loader::db();
		$db->query("DELETE FROM btImageBannerImg WHERE bID=".intval($this->bID));		
		parent::delete();
	}
	
	function loadBlockInformation() {
		$this->loadImages();
		$this->set('images', $this->images);	
		$this->set('width', $this->width); 
		$this->set('height', $this->height); 
		$this->set('bID', $this->bID);				
	}
	
	function view() {
		$this->loadBlockInformation();
	}

	function add() {
		$this->loadBlockInformation();

	}
	
	function edit() {
		$this->loadBlockInformation();
	}
	
	function duplicate($nbID) {
		parent::duplicate($nbID);
		$this->loadBlockInformation();
		$db = Loader::db();
		foreach($this->images as $im) {
			$db->Execute('insert into btImageBannerImg (bID, fID, position, imgHeight, xcrop, ycrop) values (?, ?, ?, ?, ?, ?)', 
				array($nbID, $im['fID'],  $im['position'], $im['imgHeight'],  $im['xcrop'],  $im['ycrop'])
			);		
		}
	}
	
	function save($data) { 
 
		$db = Loader::db();
		
		 if( count($data['imgFIDs']) ){
			//delete existing images
			$db->query("DELETE FROM btImageBannerImg WHERE bID=".intval($this->bID));
			
			//loop through and add the images
			$pos=0;
			foreach($data['imgFIDs'] as $imgFID){ 
				if(intval($imgFID)==0 || $data['fileNames'][$pos]=='tempFilename') continue;
				$vals = array(intval($this->bID),intval($imgFID), intval($data['imgHeight'][$pos]),$pos, $data['xcrop'][$pos], $data['ycrop'][$pos]);
				$db->query("INSERT INTO btImageBannerImg (bID,fID,imgHeight,position, xcrop, ycrop) values (?,?,?,?,?,?)",$vals);
				$pos++;
			}
		}
		
		$args['width']= (int)$data['width'];
		$args['height']= (int)$data['height'];
 
 		// some protection against saves that sneak through the javascript validation
 		// better to not save than to allow invalid widths or heights
 		if ($args['width'] > 0 && $args['height'] > 0) {
			parent::save($args);
					
			$co = new Config();
			$pkg = Package::getByHandle("image_banner");
			$co->setPackageObject($pkg);
			$co->save('width', $args['width']);
			$co->save('height', $args['height']);
			
		} else {
			return false;
		}
	}
	
	 
}

?>
