<?php  
defined('C5_EXECUTE') or die(_("Access Denied."));

class JbYoutubebackgroundFreeBlockController extends BlockController {

	protected $btTable = 'btJbYoutubebackgroundtabFree';
	protected $btInterfaceWidth = "400";
	protected $btInterfaceHeight = "220";

	public $content = "";
	public $videowidth = 400;
	public $opacity = 0.5;
	public $isBgndMovie = true;
	public $ratio = '4/3';
	public $quality = 'default';
	public $muteSound = 1;
	public $addRaster = 0;
	public $elementID = "";

	public function getBlockTypeDescription() {
		return "Add YouTube video to page background";
	}

	public function getBlockTypeName() {
		return "YouTube Background FREE";
	}

	public function __construct($obj = null) {
		parent::__construct($obj);
	}
	
	public function on_page_view() {
	  $mobilelist=array('iPhone','iPad','iPod');

		//check if mobile device
		$ismobiledevice = false;
		$httpuseragent = $_SERVER['HTTP_USER_AGENT'];
		foreach($mobilelist as $mobcheck) {
			if (strpos($httpuseragent,$mobcheck)){
				$ismobiledevice = true;
				break;
			}
		}
	  if (!$ismobiledevice){
	  $this->addHeaderItem('<script type="text/javascript">$(function(){$(".bgmoviejb").mb_YTPlayer();});</script>');
	  }
	}


	public function view(){
		$this->set('content', $this->content);
		$this->set('videowidth', $this->videowidth);
		$this->set('opacity', $this->opacity);
		$this->set('ratio', $this->ratio);
		$this->set('muteSound', $this->muteSound);
		$this->set('bufferImageFileID', $this->bufferImageFileID);
		$this->set('addRaster', $this->addRaster);
		$this->set('elementID', $this->elementID);
		
		
	}

	public function save($data) {
		//$args['videowidth'] = isset($data['videowidth']) ? $data['videowidth'] : 400;
		$args['content'] = isset($data['content']) ? $data['content'] : '';
		$args['opacity'] = isset($data['opacity']) ? $data['opacity'] : '100';
		$args['ratio'] = isset($data['ratio']) ? $data['ratio'] : '4/3';
		$args['muteSound'] = isset($data['muteSound']) ? intval($data['muteSound']) : 0;
		$args['bufferImageFileID'] = isset($data['bufferImageFileID']) ? intval($data['bufferImageFileID']) : null;
		$args['addRaster'] = isset($data['addRaster']) ? intval($data['addRaster']) : 0;
		$args['elementID'] = isset($data['elementID']) ? $data['elementID'] : null;
		parent::save($args);
	}
	
	function getFileID() {return $this->bufferImageFileID;}
	function getFileObject() {
		return File::getByID($this->bufferImageFileID);
	}		
		
}

?>